package fa;

import ec.*;
import ec.gp.*;
import ec.simple.*;
import ec.util.*;

public abstract class AlgebraProblem extends GPProblem
				     implements SimpleProblemForm
{
	public int n;		// number of elements in the algebra
	public byte x, y, z;	// input variables to the term

	public Element input;

	// number of fitness cases
	public int m()
	{
		return (n * n * n);
	}

	public Object clone()
	{
		AlgebraProblem obj = (AlgebraProblem)super.clone();
		obj.input = (Element)input.clone();
		obj.n = n;
		return obj;
	}

	public void setup(final EvolutionState state,
			  final Parameter base)
	{
		super.setup(state, base);

		input = (Element)state.parameters.getInstanceForParameterEq(
				base.push(P_DATA), null, Element.class);
		input.setup(state, base.push(P_DATA));

		n = state.parameters.getIntWithMax(base.push("n"), null, 2, 127);
		if (n < 2)
			state.output.fatal("Algebra size must be in 2..127");
	}

	public byte eval(final EvolutionState s,
			final Individual ind,
			final int t)
	{
		((GPIndividual)ind).trees[0].child.eval(s, t, input, stack,
							(GPIndividual)ind,
							this);
		return input.i;
	}
}
