package fa;

import java.util.*;

import fa.util.BooleanMultiFitness;

import ec.*;
import ec.gp.*;
import ec.util.*;

public class DepthNodeSelector implements GPNodeSelector 
{
	public int m;
	public double dScale, dOffset;

	public GPNode pickNode(final EvolutionState s,
			       final int subpop,
			       final int thr,
			       final GPIndividual ind,
			       final GPTree tree)
	{
		double e = ((BooleanMultiFitness)ind.fitness).misses();
		int d = (int)(dScale * Math.log(e) + dOffset);

		GPNode p = tree.child; 

		ArrayList<GPNode> a = new ArrayList<GPNode>();
		slice(p, d, a);
		if (a.size() > 0)
			p = a.get(s.random[thr].nextInt(a.size()));
		else
			while (p.children.length > 0)
				p = p.children[s.random[thr].nextInt(p.children.length)];

		return p;
	}

	public void slice(GPNode p, int d, ArrayList<GPNode> a)
	{
		for (GPNode q : p.children)
			slice(q, d - 1, a);
		if (d <= 0)
			a.add(p);
	}

	public Object clone()
	{
		try {
			return super.clone();
		} catch(Exception e) {}
		return null;
	}

	public void setup(EvolutionState s, Parameter param)
	{
		double n = ((AlgebraProblem)s.evaluator.p_problem).n;
		m = ((AlgebraProblem)s.evaluator.p_problem).m();
		dScale = Math.log((n - 1.0) / n);
		dOffset = -Math.log((double)m) / dScale;
		dScale = 1.0 / dScale;
	}

	public void reset() {}

	public Parameter defaultBase() { return null; }
}
