package fa;

import ec.*;
import ec.gp.koza.*;

public class Discriminator extends AlgebraProblem
{
	public void evaluate(final EvolutionState s,
			     final Individual ind,
			     final int t)
	{
		if (ind.evaluated)
			return;

		int r;
		int xmiss = 0, zmiss = 0;
		for (x = 0; x < n; ++x)
			for (y = 0; y < n; ++y)
				for (z = 0; z < n; ++z) {
					r = eval(s, ind, t);
					if (x == y) {
						if (r != z)
							++zmiss;
					} else if (r != x)
						++xmiss;
				}

		float fitness = xmiss + (n - 1) * zmiss;

		if (ind.size() == 1)
			fitness *= n * n;

		KozaFitness f = (KozaFitness)ind.fitness;
		f.setStandardizedFitness(s, fitness); 
		f.hits = n * n * n - xmiss - zmiss;

		ind.evaluated = true;
	}
}
