package fa;

import fa.util.BooleanMultiFitness;

import java.util.Arrays;

import ec.*;
import ec.util.*;

public class DiscriminatorTable extends TableProblem
{
	public byte[][] m, p, d;

	public void Malcev()
	{
		m = new byte[2 * n * n - n][4];

		int i = 0;
		for (byte a = 0; a < n; ++a)
			for (byte b = 0; b < n; ++b) {
				m[i][X] = m[i][Y] = a;
				m[i][Z] = m[i][RESULT] = b;
				++i;

				if (a != b) {
					m[i][X] = m[i][RESULT] = a;
					m[i][Y] = m[i][Z] = b;
					++i;
				}
			}
	}

	public void Pixley()
	{
		p = new byte[3 * n * n - 2 * n][4];

		int i = 0;
		for (byte a = 0; a < n; ++a)
			for (byte b = 0; b < n; ++b) {
				p[i][X] = p[i][Z] = p[i][RESULT] = a;
				p[i][Y] = b;
				++i;

				if (a != b) {
					p[i][X] = p[i][RESULT] = a;
					p[i][Y] = p[i][Z] = b;
					++i;

					p[i][X] = p[i][Y] = b;
					p[i][Z] = p[i][RESULT] = a;
					++i;
				}
			}
	}

	public void discriminator()
	{
		d = new byte[n * n * n][4];

		int i = 0;
		for (x = 0; x < n; ++x)
			for (y = 0; y < n; ++y)
				for (z = 0; z < n; ++z) {
					d[i][X] = x;
					d[i][Y] = y;
					d[i][Z] = z;
					d[i][RESULT] = (x == y) ? z : x;
					++i;
				}
	}

	public void setup(final EvolutionState state, final Parameter base)
	{
		super.setup(state, base);

		int i = 0;

		tab = new byte[n * n * n][4];

		Malcev();
		do
			tab[i] = m[i];
		while (++i < m.length);

		Pixley();
p0:		for (byte[] r : p) {
			for (byte[] t : tab)
				if (Arrays.equals(r, t))
					continue p0;
			tab[i++] = r;
		}

		/*
		 * This takes time proportional to the sixth power of n.
		 * Fortunately, n is four.
		 */
		discriminator();
d0:		for (byte[] r : d) {
			for (byte[] t : tab)
				if (Arrays.equals(r, t))
					continue d0;
			tab[i++] = r;
		}
	}

	public void evaluate(final EvolutionState state,
			     final Individual ind,
			     final int thread)
	{
		if (ind.size() == 1) {
			/* sigh... */
			boolean[] bogus = new boolean[tab.length];
			for (int i = 0; i < tab.length; ++i)
				bogus[i] = true;
			((BooleanMultiFitness)ind.fitness).setFitness(bogus);
			ind.evaluated = true;
			return;
		}

		super.evaluate(state, ind, thread);
		try {
			AlgebraFitness f = (AlgebraFitness)ind.fitness;

			f.malcev = 0;
			for (int i = 0; i < m.length; ++i)
				if (f.p[i])
					++f.malcev;
			f.pixley = f.malcev;
			for (int i = m.length; i < p.length; ++i)
				if (f.p[i])
					++f.pixley;
		} catch (ClassCastException e) {}
	}
}
