package fa;

import fa.util.BooleanMultiFitness;

import ec.*;
import ec.util.*;

public class MajorityTable extends TableProblem
{
	public byte[][] majority()
	{
		byte[][] m = new byte[3 * n * n - 2 * n][4];

		int i = 0;
		for (byte a = 0; a < n; ++a)
			for (byte b = 0; b < n; ++b) {
				m[i][X] = m[i][Y] = m[i][RESULT] = a;
				m[i][Z] = b;
				++i;

				if (a != b) {
					m[i][X] = m[i][Z] = m[i][RESULT] = a;
					m[i][Y] = b;
					++i;

					m[i][X] = b;
					m[i][Y] = m[i][Z] = m[i][RESULT] = a;
					++i;
				}
			}

		return m;
	}

	public void setup(final EvolutionState state, final Parameter base)
	{
		super.setup(state, base);

		tab = majority();
	}

	public void evaluate(final EvolutionState state,
			     final Individual ind,
			     final int thread)
	{
		if (ind.size() == 1) {
			boolean[] bogus = new boolean[tab.length];
			for (int i = 0; i < tab.length; ++i)
				bogus[i] = true;
			((BooleanMultiFitness)ind.fitness).setFitness(bogus);
			ind.evaluated = true;
		} else
			table_eval(state, ind, thread);
	}
}
