package fa;

import ec.*;
import ec.gp.koza.*;

public class Malcev extends AlgebraProblem
{
	public void evaluate(final EvolutionState s,
			     final Individual ind,
			     final int t)
	{
		if (ind.evaluated)
			return;

		int misses = 0;
		for (byte a = 0; a < n; ++a)
			for (byte b = 0; b < n; ++b) {
				x = y = a;
				z = b;
				if (eval(s, ind, t) != b)
					++misses;
				if (a != b) {
					y = b;
					if (eval(s, ind, t) != a)
						++misses;
				}
			}

		float fitness = misses;
		if (ind.size() == 1)
			fitness *= n * n;

		KozaFitness f = (KozaFitness)ind.fitness;
		f.setStandardizedFitness(s, fitness);
		f.hits = 2 * n * n - n - misses;

		ind.evaluated = true;
	}

	public int m() { return (2 * n * n - n); }
}
