package fa;

import fa.util.BooleanMultiFitness;

import ec.*;

public abstract class TableProblem extends AlgebraProblem
{
	public static final int X = 0;
	public static final int Y = 1;
	public static final int Z = 2;
	public static final int RESULT = 3;

	public byte[][] tab;

	protected void table_eval(final EvolutionState state,
				  final Individual ind,
				  final int thread)
	{
		if (ind.evaluated)
			return;

		byte[] evaltab = new byte[tab.length];
		for (int i = 0; i < tab.length; ++i) {
			x = tab[i][X];
			y = tab[i][Y];
			z = tab[i][Z];
			evaltab[i] = eval(state, ind, thread);
		}

		boolean[] fitnesstab = new boolean[tab.length];
		for (int i = 0; i < tab.length; ++i)
			fitnesstab[i] = (evaltab[i] != tab[i][RESULT]);
		((BooleanMultiFitness)ind.fitness).setFitness(fitnesstab);

		ind.evaluated = true;
	}

	public void evaluate(final EvolutionState state,
			     final Individual ind,
			     final int thread)
	{
		table_eval(state, ind, thread);
	}

	public int m() { return tab.length; }

	public Object clone()
	{
		TableProblem obj = (TableProblem)super.clone();
		obj.tab = tab;
		return obj;
	}
}
