package fa.util;

import ec.*;

public class AlphaSet
{
	/*
	 * Given the size of the alpha set as a percentage (0..100) of
	 * the total population, return a floating-point number to be
	 * dithered to an integer tournament size.
	 */
	public static double tourneySize(double a)
	{
		return Math.max(2.0, 11.0 - Math.min(10.0, a));
	}

	public static int findAlpha(Population p)
	{
		int a = 0;
		Fitness best = p.subpops[0].individuals[0].fitness;

		for (Subpopulation sp : p.subpops)
			for (Individual i : sp.individuals) 
				if (i.fitness.equivalentTo(best))
					++a;
				else if (i.fitness.betterThan(best)) {
					best = i.fitness;
					a = 1;
				}
		return a;
	}
}
