package fa.util;

import ec.*;
import ec.gp.*;
import ec.util.*;

public class SizefairMutator extends GPNodeBuilder
{
	public GPNodeBuilder build;
	public double range;

	public GPNode newRootedTree(final EvolutionState state,
				    final GPType type,
				    final int thread,
				    final GPNodeParent parent,
				    final GPFunctionSet set,
				    final int argpos,
				    final int s)
	{
		if (s == NOSIZEGIVEN)
			state.output.fatal("Size-fair mutation needs requestedSize = the size of the subtree to be replaced.");

		int r = (int)(range * s);
		if (r < 1)
			r = 1;

		int target = s + (state.random[thread].nextInt(2 * r + 1) - r);

		return build.newRootedTree(state, type, thread, parent, set,
					   argpos, target);
	}

	public Parameter defaultBase()
	{
		return (new Parameter("mutate-sizefair"));
	}

	public void setup(final EvolutionState state, final Parameter base)
	{
		super.setup(state, base);

		build = (GPNodeBuilder)state.parameters.getInstanceForParameter(
				base.push("build"), defaultBase().push("build"),
				GPNodeBuilder.class);
		build.setup(state, base.push("build"));

		range = state.parameters.getDouble(base.push("range"),
						   defaultBase().push("range"),
						   0.0, 1.0);
		if (range < 0.0)
			state.output.fatal("Size range must be in 0..1",
					   base.push("range"),
					   defaultBase().push("range"));
						
	}
}
